setlocal isk+=_

if exists("loaded_cweb_plugin")
    finish
endif
let loaded_cweb_plugin = 1


function! CWEBTag()
    if &filetype != "cweb"
        try
            exec ":tag"
        catch /^Vim\((\a\+)\)\=:E\d\+:/
            echo "Internal error (" . v:exception . ")"
        endtry
    else
        let s = getline(".")
        let col = col(".") - 1
        let left = strpart(s, 0, col + 1)
        let right = strpart(s, col)
        let left_index = strridx(left, "@<")
        let right_index = stridx(right, "@>")
        if left_index == -1 || right_index == -1
            " not in a section, call normal tag function
            " :tag<CR>
            echo "No section name found at this position"
        else
            " ok, we are in a section
            let len = col - left_index + right_index + 2
            let tagexp = strpart(s, left_index, len)
            try
                exec ":tag " . tagexp
            catch /^Vim\((\a\+)\)\=:E\d\+:/
                echo "Internal error (" . v:exception . ")"
            endtry
        endif
    endif
endfunction

map ,, :call CWEBTag()<CR>
