function! ChangeStyle() range
    let x = a:firstline
    let y = a:lastline
    while x <= y
        let start  = 0
        let line = getline(x)
        let result = ''
        let word   = ''

        let idx = match(line,'\<\i*\>',start)
        while idx >= start
            let result = result . strpart(line,start,idx - start)
            let word = matchstr(line,'\<\i*\>',start)
            let start = idx + strlen(word)
            let result = result . ChangeWordStyle(word)
            let idx = match(line,'\<\i*\>',start)
        endwhile
        let result = result . strpart(line,start)
        call setline(x,result)
        let x = x + 1
    endwhile
endfunction

function! ChangeWordStyle(word)
    let w = a:word
"    if w =~'^[A-Z_]'
"        return w
"    endif
    let len = strlen(w)
    let i = 0
    let w2 = ''
    while i < len
        let ch = strpart(w,i,1)
        if ch =~# '[A-Z]' && strpart(w,i-1,1) =~# '[a-z]' && strpart(w,i+3,1) !~# '[A-Z]'
            let ch = '_' . tolower(ch)
        endif

        if w2 == 'mp'
            let w2 = 'm' . ch
        else
            let w2 = w2 . ch
        endif

        let i = i + 1
    endwhile
    return w2
endfunction

autocmd BufReadPre *.gbk setlocal bin
autocmd BufRead *.gbk call All2Utf8()
function! All2Utf8()
    echo system("file " . expand("<afile>"))
    let lines = line('$')
    let i = 1
    while i <= lines
        let s1 = getline(i)
        let s2 = iconv(s1,"GB2312","UTF-8")
        if s2 != ""
            call setline(i,s2)
        endif
        let i = i + 1
    endwhile
    setlocal nobin
endfunction
